' This is file h_2_bi.bas, Version 0.0:
'
' h_2_bi generates a FreeBasic-Header file from C headers
' (and the file 'test.bas' to compile the FB-Header).
'
' Copyright by Thomas.Freiherr@gmx.net
'
' Licence:
'
' h_2_bi.bas is free software: you can redistribute
' it and/or modify it under the terms of the GNU General Public
' License as published by the Free Software Foundation, either
' version 3 of the License, or (at your option) any later
' version. For details please refer to: http://gplv3.fsf.org/
'
' h_2_bi.bas is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

#INCLUDE "file.bi"
#IFDEF __FB_LINUX__
# DEFINE NL CHR(10)
# DEFINE SLASH "/"
#ELSE
# DEFINE NL CHR(13, 10)
# DEFINE SLASH "\"
#ENDIF
#DEFINE PROG_NAME "h_2_bi"
#DEFINE PROG_VERS "0.0"
#DEFINE REPFU "nofunc"
#DEFINE REPTY "types"
#DEFINE REPPO "post"
#DEFINE LTRI ANY !" \t\r\n"
#DEFINE TRI LTRI & ";"
#DEFINE TYKENN "_TJF"
#DEFINE EINR "  "

' structure for reading C-Header
' Datenstruktur fuer das Bearbeiten des C-Headers
TYPE readDaten
  AS STRING FNam, Wort, LaWo, Murx
  AS INTEGER Eb, fnr
  AS UBYTE z, a
END TYPE

' structure for replacements
' Datenstruktur fuer verschiedene Wandlungsaufgaben
TYPE replaceDaten
  AS STRING Su, Er
END TYPE

' global VARs / globale Variablen
DIM SHARED AS INTEGER EMAX = 1, ERRFL
REDIM SHARED AS replaceDaten POST(0), TYPES(0), NOFUNC(0)
REDIM SHARED AS STRING F_OK(0), F_KO(0), FOLD(0)
REDIM SHARED AS STRING IFDEF(0), TYNAM(0)
DIM SHARED AS STRING IFSTA, RES
IFDEF(0) = MKSHORT(0)
TYPES(0).Su = "void"
TYPES(0).Er = "ANY"

' needed because of recursion / notwendig wegen Rekursion
DECLARE SUB readCHeader(BYVAL F AS STRING, BYVAL Eb AS INTEGER)
DECLARE SUB getNaTy(BYVAL T AS STRING, BYREF Na AS STRING, BYREF Ty AS STRING)
DECLARE FUNCTION BlockTyUn(BYVAL Rd AS readDaten PTR, _
                           BYREF T AS STRING, BYVAL S AS INTEGER, _
                           BYVAL E AS INTEGER, BYVAL N AS STRING, _
                           BYVAL O AS STRING) AS STRING

' serving name for output file, writing 'test.bas'
' liefert den Namen fuer die Ausgabedatei, schreibt 'test.bas'
FUNCTION getFileNam(BYVAL T AS STRING) AS STRING
  DIM AS STRING f = "test.bas" , r = MID(T, INSTRREV(T, SLASH) + 1) & ".bi"
  IF NOT FILEEXISTS(f) THEN
    DIM AS INTEGER fnr = FREEFILE
    IF OPEN (f FOR OUTPUT AS #fnr) THEN
      ?"Unable to write: " & f
    ELSE
      PRINT #fnr, "#INCLUDE """ & r & """"
      CLOSE #fnr
    END IF
  END IF : RETURN r
END FUNCTION

' storing new TYPE name
' speichert neuen Namen fuer TYPE-Benennung
SUB TynamNeu(BYVAL T AS STRING)
  IF LEN(T) = 0 THEN EXIT SUB
  DIM AS INTEGER n = UBOUND(TYNAM) + 1
  REDIM PRESERVE TYNAM(n)
  TYNAM(n) = T
END SUB

' serving name extension, if TYPE is known (or nothing)
' liefert Anhang, wenn TYPE bekannt (sonst nichts)
FUNCTION checkTynam(BYVAL T AS STRING) AS STRING
  FOR i AS INTEGER = 1 TO UBOUND(TYNAM)
    IF TYNAM(i) = T THEN RETURN TYKENN
  NEXT : RETURN ""
END FUNCTION

' storing new comment for '#endif'
' speichert neuen Kommentar fuer '#endif'
SUB IfNeu(BYVAL T AS STRING)
  IF LEN(T) = 0 THEN IFSTA += MKSHORT(0) : EXIT SUB
  DIM AS INTEGER n = CVSHORT(IFDEF(0))
  n += 1
  IF n > UBOUND(IFDEF) THEN REDIM PRESERVE IFDEF(n)
  IFSTA +=  MKSHORT(n)
  IFDEF(n) = T
  IFDEF(0) = MKSHORT(n)
END SUB

' serving matching comment for '#endif'
' liefert passenden Kommentar fuer '#endif'
FUNCTION IfCom() AS STRING
  DIM AS INTEGER n = CVSHORT(RIGHT(IFSTA, 2)), l = LEN(IFSTA)
  IFSTA = LEFT(IFSTA, l - 2)
  IF n = 0 THEN RETURN ""
  IFDEF(0) = MKSHORT(n - 1)
  RETURN " ' " & IFDEF(n)
END FUNCTION

' checking if z is a name charakter
' prueft ob das Zeichen z zu einem Namen gehoert
FUNCTION checkName(BYVAL Z AS UBYTE) AS INTEGER
  IF Z < ASC("A") THEN
    IF Z <= ASC("9") THEN IF Z >= ASC("0") THEN RETURN -1
    RETURN 0
  ELSE
    IF Z <= ASC("Z") THEN RETURN -1
    IF Z >= ASC("a") THEN IF Z <= ASC("z") THEN RETURN -1
    IF Z = ASC("_") THEN RETURN -1
  END IF : RETURN 0
END FUNCTION

' storing new data in replaceDaten
' nimmt neuen Datensatz in Replace-Daten auf
SUB neuRepDat(BYVAL Su AS STRING, BYVAL Er AS STRING, Ud() AS replaceDaten)
  DIM AS INTEGER n = UBOUND(Ud) + 1
  REDIM PRESERVE Ud(n)
  Ud(n).Su = Su
  Ud(n).Er = Er
END SUB

' checking text line, reading and storing replaceDaten
' prueft Textzeile, separiert Replace-Daten und speichert sie
SUB checkRepDat(BYREF T AS STRING, Ud() AS replaceDaten)
  DIM AS INTEGER p = INSTR(T, ">")
  IF p THEN neuRepDat(LEFT(T, p - 1), MID(T, p + 1), ud()) : EXIT SUB
  p = INSTR(T, "&") : IF p <= 1 THEN EXIT SUB
  DIM AS STRING w = LEFT(T, p - 1)
  neuRepDat(w, w & MID(T, p + 1), ud())
END SUB

' reading replace file, storing context
' liest eine Replace-Datei und speichert den Inhalt
SUB readRepDat(BYVAL F AS STRING, Ud() AS replaceDaten)
  DIM AS INTEGER p, ub = UBOUND(ud), fnr = FREEFILE
  DIM AS STRING z = F & ".rep"
  IF OPEN (z FOR INPUT AS #fnr) THEN
    ?"Unable to read: " & z
  ELSE
    WHILE NOT EOF(fnr)
      LINE INPUT #fnr, z
      checkRepDat(z, Ud())
    WEND : CLOSE #fnr
  END IF
END SUB

' reading text file .ini, storing file name and folders
' liest eine Textdatei, speichert Dateiname und Pfade
SUB readFilDat(BYVAL F AS STRING)
  DIM AS STRING zeile
  DIM AS INTEGER n = 0, fnr = FREEFILE
  IF OPEN (F FOR INPUT AS #fnr) THEN
    ?"Unable to read: " & F
  ELSE
    IF NOT EOF(fnr) THEN
      LINE INPUT #fnr, FOLD(0)
      WHILE NOT EOF(fnr)
        LINE INPUT #fnr, zeile
        IF LEN(zeile) THEN
          n += 1
          REDIM PRESERVE FOLD(n)
          IF RIGHT(zeile, 1) <> SLASH THEN zeile += SLASH
          FOLD(n) = zeile
        END IF
      WEND : CLOSE #fnr
    END IF
  END IF
END SUB

' reading text file, serving context
' liest eine Textdatei, liefert gesamten Inhalt als String
FUNCTION getDatei(BYVAL F AS STRING) AS STRING
  DIM AS STRING zeile, r
  DIM AS INTEGER fnr = FREEFILE
  IF OPEN (F FOR INPUT AS #fnr) THEN
    ?"Unable to read: " & F
  ELSE
    WHILE NOT EOF(fnr)
      LINE INPUT #fnr, zeile
      r += zeile & NL
    WEND : CLOSE #fnr
  END IF : RETURN r
END FUNCTION

' writing RES in file Fnr, replacing words difined in Ud()
' schreibt RES in Datei Fnr, ersetzt Woerter gemaess Ud()
SUB PostReplace(BYVAL Fnr AS INTEGER, Ud() AS replaceDaten)
  DIM AS INTEGER ub = UBOUND(Ud)
  IF ub = 0 THEN PRINT #fnr, RES : EXIT SUB
  DIM AS INTEGER fl, i, j, l, p(ub)
  DIM AS STRING w
  FOR i = 0 TO LEN(RES) - 1
    IF checkName(RES[i]) THEN
      FOR j = 1 TO ub
        IF RES[i] = Ud(j).Su[p(j)] THEN
          fl = -1
          p(j) += 1
        ELSE
          p(j) = 0
        END IF
      NEXT : w += CHR(RES[i])
    ELSE
      IF fl THEN
        FOR j = 1 TO ub
          WITH Ud(j)
            IF p(j) = LEN(.Su) THEN IF p(j) = LEN(w) THEN w = .Er
          END WITH
          p(j) = 0
        NEXT
        fl = 0
      END IF : PRINT #Fnr, w; CHR(RES[i]);
      w = ""
    END IF
  NEXT
END SUB

' generating a comment line with tab
' erzeugt eine Kommentarzeile mit Tabulator
FUNCTION ZeileProtSect(BYVAL T AS STRING, BYVAL N AS UINTEGER) AS STRING
  RETURN "'" & RIGHT(STRING(54, " ") & T, 54) & ": " & N
END FUNCTION

' writing context of -rep file into output file Fnr
' schreibt Inhalt der .rep-Datei als Kommentar in Ausgabedatei Fnr
SUB writeRepFile(BYVAL Fnr AS INTEGER, BYVAL T AS STRING, Ud() AS replaceDaten)
  IF UBOUND(Ud) = 0 THEN EXIT SUB
  PRINT #Fnr, ZeileProtSect("Lines in " & T & ".rep", UBOUND(Ud))
  FOR i AS INTEGER = 1 TO UBOUND(Ud)
    WITH Ud(i)
      IF LEFT(.Er, LEN(.Su)) = .Su THEN
        PRINT #Fnr, "'"; .Su; "&"; MID(.Er, LEN(.Su) + 1)
      ELSE
        PRINT #Fnr, "'"; .Su; ">"; .Er
      END IF
    END WITH
  NEXT
END SUB

' writing translation result into output file, doing post.rep replacements
' schreibt das Ergebnis der Wandlung in Datei, ggf. Replace
SUB writeBi(BYVAL F AS STRING, Ud() AS replaceDaten)
  ?"      files done:"; UBOUND(F_OK)
  ?"    files missed:"; UBOUND(F_KO)
  FOR i AS INTEGER = 1 TO UBOUND(F_KO)
    ?F_KO(i)
  NEXT
  ?"    Maximum deep:"; EMAX
  ?
  ?"       directory: "; CURDIR
  ?"     output file: "; F
  ?"Bytes translated:"; LEN(RES)

  DIM AS INTEGER fnr = FREEFILE
  IF OPEN (F FOR OUTPUT AS #fnr) THEN
    ?"Can not write: " & F
  ELSE
    PostReplace(fnr, Ud())
    PRINT #fnr, "'00end: "; F
    PRINT #fnr, ""
    PRINT #fnr, "'Translated by '" & PROG_NAME & ".bas', version " & PROG_VERS
    PRINT #fnr, "'Open source from Thomas.Freiherr@gmx.net"
    PRINT #fnr, ZeileProtSect("Files done", UBOUND(F_OK))
    PRINT #fnr, ZeileProtSect("Files missed", UBOUND(F_KO))
    FOR i AS INTEGER = 1 TO UBOUND(F_KO)
      PRINT #fnr, "'" & F_KO(i)
    NEXT
    writeRepFile(fnr, REPFU, NOFUNC())
    writeRepFile(fnr, REPTY, TYPES())
    writeRepFile(fnr, REPPO, POST())
    PRINT #fnr, ZeileProtSect("Maximum deep", EMAX)
    PRINT #fnr, ZeileProtSect("Bytes translated", LEN(RES))
    CLOSE #fnr
  END IF
END SUB

' replacing I by S in STRING T
' erstetzt im String T Zeichenkette I durch Zeichenkette S
SUB STRreplace(BYREF T AS STRING, BYVAL I AS STRING, BYVAL S AS STRING)
  DIM AS INTEGER e, a = INSTR(T, I)
  WHILE a
    e = a + LEN(I)
    T = LEFT(T, a - 1) & S & MID(T, e)
    a = INSTR(a + LEN(S), T, I)
  WEND
END SUB

' storing (multi line) comment in RES
' speichert (ggf. mehrzeiligen) Kommentar in RES
SUB AusKom(BYREF Z AS STRING)
  IF LEN(Z) = 0 THEN EXIT SUB
  STRreplace(Z, NL, NL & "' ")
  RES += "' " & Z & NL
END SUB

' storing Murx as comment in RES
' speichert Murx-Block als Kommentar in RES
SUB AusMurx(BYVAL Rd AS readDaten PTR)
  WITH *Rd
    .Murx = RTRIM(.Murx, LTRI)
    IF LEN(.Murx) = 0 THEN EXIT SUB
    IF .LaWo <> "murx" THEN RES += NL : .LaWo = "murx"
    AusKom(.Murx)
    .Murx = ""
  END WITH
END SUB

' storing new translation in RES
' speichert neue Uebersetzung in RES
SUB AusRes(BYVAL Rd AS readDaten PTR, BYREF T AS STRING)
  WITH *Rd
    AusMurx(Rd)
    IF .LaWo <> .Wort THEN RES += NL : .LaWo = .Wort
    ERRFL = 0
  END WITH : RES += T & NL
END SUB

' searching for context of {}
' sucht Inhalt von aeusseren {} im Text T, prueft Anzahl (auf und zu)
SUB findGKlam(BYREF T AS STRING, _
              BYREF A AS INTEGER, _
              BYREF E AS INTEGER)
  DIM AS INTEGER klammer = 1, i, aa = A - 1, ee = E - 1
  FOR i = aa TO ee
    IF T[i] = ASC("{") THEN EXIT FOR
  NEXT : aa = i + 1
  FOR i = aa TO ee
    SELECT CASE T[i]
    CASE ASC("{") : klammer += 1
    CASE ASC("}") : klammer -= 1 : IF klammer = 0 THEN EXIT FOR
    END SELECT
  NEXT : IF klammer THEN E = A - 1 : EXIT SUB '                   Fehler
  A = aa + 1 : E = i
END SUB

' reading new name (union, struct) before (or after) {}
' liest einen Namen (union, struct) vor oder ggf. hinter {}
FUNCTION getName(BYREF T AS STRING, _
                 BYVAL A AS INTEGER, _
                 BYVAL E AS INTEGER) AS STRING
  DIM AS STRING na = TRIM(LEFT(T, a - 2), TRI)
  IF LEN(na) THEN RETURN na
  RETURN TRIM(MID(T, e + 2), TRI)
END FUNCTION

' overreading a comment in .h
' liest einen Kommentar aus .h, verwirft ihn
SUB readComm(BYVAL Rd AS readDaten PTR)
  DIM AS UBYTE lz
  WITH *Rd
    WHILE NOT EOF(.fnr)
      GET #.fnr, , .z
      IF .z = ASC("/") THEN IF lz = ASC("*") THEN EXIT WHILE
      lz = .z
    WEND
  END WITH
END SUB

' reading a C block from .h, overreading comments
' liest einen C-Quelltest-Block aus .h, verwirft ggf. Kommentare
FUNCTION readCBlock(BYVAL Rd AS readDaten PTR) AS STRING
  DIM AS INTEGER klammer
  DIM AS STRING l
  WITH *Rd
    WHILE NOT EOF(.fnr)
      GET #.fnr, , .z
      SELECT CASE .z
      CASE ASC(";") : IF klammer = 0 THEN EXIT WHILE
      CASE ASC("{") : klammer += 1
      CASE ASC("}") : klammer -= 1
      CASE ASC("*")
        IF RIGHT(l, 1) = "/" THEN
          readComm(Rd)
          l = LEFT(l, LEN(l) - 1)
          .z = ASC(" ")
        END IF
      END SELECT : l += CHR(.z)
    WEND : RETURN TRIM(l, LTRI)
  END WITH
END FUNCTION

' checking T for C logic, replacing by FB commands
' prueft T auf C-LogiK-Befehle, ersetzt sie durch FB-Befehle
SUB checkLogic(BYREF T AS STRING)
  STRreplace(T, ">>", "SHR")
  STRreplace(T, "<<", "SHL")
  STRreplace(T, "||", "OR") ' ORELSE in '#if' nicht erlaubt!!
  STRreplace(T, "&&", "AND") ' ANDALSO in '#if' nicht erlaubt!!
  STRreplace(T, "==", "=")
  STRreplace(T, "!=", "<>")
  STRreplace(T, "!", "0=")
  STRreplace(T, "^", "XOR")
  STRreplace(T, "~", "NOT ")
  STRreplace(T, "|", "OR")
  STRreplace(T, "&", "AND")
  STRreplace(T, "0x", "&h")
  STRreplace(T, "0b", "&b")
  DIM AS INTEGER p, a = INSTR(T, "?"), e = INSTR(a + 1, T, ":")
  WHILE a * e '                                                     IIFs
    IF a > e THEN EXIT WHILE
    MID(T, a, 1) = ","
    MID(T, e, 1) = ","
    p = 1
    FOR i AS INTEGER = a TO 1 STEP -1
      IF MID(T, i, 1) = ")" THEN p += 1
      IF MID(T, i, 1) = "(" THEN p -= 1
      IF p = 0 THEN p = i : EXIT FOR
    NEXT
    T = LEFT(T, p - 1) & "IIF" & MID(T, p)
    a = INSTR(T, "?")
    e = INSTR(a + 1, T, ":")
  WEND
END SUB

' cheching file by name (done, exists)
' pueft, ob Datei bereits bearbeitet wurde
FUNCTION checkFNam(BYVAL Rd AS readDaten PTR, BYVAL F AS STRING) AS INTEGER
  DIM AS STRING r
  WITH *rd
    IF FILEEXISTS(F) THEN .FNam = F : RETURN 0
    FOR j AS INTEGER = 1 TO UBOUND(FOLD)
      r = FOLD(j) & F
      IF FILEEXISTS(r) THEN
        FOR i AS INTEGER = 1 TO UBOUND(F_OK)
          IF r = F_OK(i) THEN
            .FNam = "file already done: " & r : RETURN 1
          END IF
        NEXT : .FNam = r : RETURN 0
      END IF
    NEXT
    FOR i AS INTEGER = 1 TO UBOUND(F_KO)
      IF F = F_KO(i) THEN .FNam = "" : RETURN 2
    NEXT
    DIM AS INTEGER e = UBOUND(F_KO) + 1
    REDIM PRESERVE AS STRING F_KO(e)
    F_KO(e) = F
    .FNam = "file not found ???: " & F : RETURN 3
  END WITH
END FUNCTION

' checking if character T is line ending
' prueft, ob T ein Zeilenende ist
FUNCTION checkZE(BYVAL T AS UBYTE) AS INTEGER
  IF INSTR(NL, CHR(T)) THEN RETURN -1
  RETURN 0
END FUNCTION

' translating 'x' in ASC("x"), placing ! befor "
' wandelt 'x' in ASC("x"), ergaenzt ! vor "
SUB checkQuotes(BYREF R AS STRING)
  DIM AS INTEGER p = INSTR(R, "'") '           Zeichen in Zahlen wandeln
  WHILE p
    R = LEFT(R, p - 1) & "ASC(""" & MID(R, p + 1)
    p = INSTR(p + 5, R, "'") : IF p = 0 THEN p = LEN(R) + 1
    R = LEFT(R, p - 1) & """)" & MID(R, p + 1)
    p = INSTR(p + 3, R, "'")
  WEND : p = INSTR(R, """") '                 STRING in C-String wandeln
  WHILE p
    R = LEFT(R, p - 1) & "!" & MID(R, p)
    p = INSTR(INSTR(p + 2, R, """") + 1, R, """")
  WEND
END SUB

' replacing array dimensions in VAR names
' ersetzt Feldgroessen in Variablennamen: [5][10] -> (0 TO 5-1, 0 TO 10-1)
SUB checkNa(BYREF Na AS STRING)
  DIM AS INTEGER za, p = INSTRREV(Na, "[")
  DIM AS STRING neu
  WHILE p
    za = VALINT(MID(Na, p + 1))
    Na = LEFT(Na, p - 1)
    IF za = 0 THEN neu = ", " : EXIT WHILE
    neu = "0 TO " & za & "-1, " + neu
    p = INSTRREV(Na, "[")
  WEND : Na = TRIM(Na, LTRI)
  p = INSTRREV(Na, ":")
  IF p THEN Na = LEFT(Na, p) & " " & VALINT(MID(Na, p + 1))
  IF LEN(neu) THEN Na += "(" & RTRIM(neu, ", ") & ")"
END SUB

' checking if the first word of T is S
' prueft, ob das erste Wort von T = S ist
FUNCTION firstWord(BYREF T AS STRING, BYVAL S AS STRING) AS INTEGER
  DIM AS INTEGER ls = LEN(S)
  IF LEN(T) < ls THEN RETURN 0
  DIM AS STRING x = LTRIM(T, LTRI)
  IF LEN(x) < ls THEN RETURN 0
  IF LEN(x) = ls THEN IF x = S THEN RETURN -1
  IF INSTR(CHR(x[ls]), LTRI & "*") THEN IF LEFT(x, ls) = S THEN RETURN -1
  RETURN 0
END FUNCTION

' checking types, replacing by definition in 'types.rep'
' prueft types, ersetzt ggf. gem. 'types.rep'
SUB checkTy(BYREF Ty AS STRING)
  DIM AS STRING a, z
  DIM AS INTEGER fl, l, p = INSTR(Ty, "*")
  WHILE p
    MID(Ty, p, 1) = " "
    z += " PTR"
    p = INSTR(p + 1, Ty, "*")
  WEND : Ty = TRIM(Ty, LTRI) : l = LEN(Ty)
  WHILE l
    DO
      fl = 1
      FOR i AS INTEGER = 0 TO UBOUND(TYPES) '  Typenwandlung 'types.rep'
        WITH TYPES(i)
          IF firstWord(Ty, .Su) THEN
            Ty = LTRIM(MID(Ty, LEN(.Su) + 1), LTRI)
            l = LEN(Ty)
            IF LEN(.Er) THEN a += .Er & " "
            fl = 0 : EXIT FOR
          END IF
        END WITH
      NEXT
    LOOP UNTIL fl
    p = INSTR(Ty, LTRI) : IF p = 0 THEN a += Ty : EXIT WHILE
    a += LEFT(Ty, p - 1) & " "
    Ty = LTRIM(MID(Ty, p + 1), LTRI)
    l = LEN(Ty)
  WEND : IF LEN(a) = 0 THEN ERRFL = -1
  Ty = TRIM(a) & z
END SUB

' searching next parameter
' sucht naechsten Parameter, prueft () im Text T, 0 wie bei INSTR
FUNCTION findPara(BYREF T AS STRING, BYVAL P AS INTEGER) AS INTEGER
  DIM AS INTEGER klammer, i
  FOR i = P - 1 TO LEN(T) - 1
    SELECT CASE T[i]
    CASE ASC(",") : IF klammer = 0 THEN RETURN i + 1
    CASE ASC("(") : klammer += 1
    CASE ASC(")") : klammer -= 1
    END SELECT
  NEXT : RETURN 0
END FUNCTION

' generating FB string from C parameter
' generiert FB-String eines C-Parameters
FUNCTION ParaListNaTy(BYVAL T AS STRING) AS STRING
  DIM AS STRING na, ty
  getNaTy(TRIM(T, TRI), na, ty)
  DIM AS INTEGER fl = INSTR(na, "0 TO ")
  IF LEN(ty) = 0 THEN
    IF fl = 0 THEN checkTy(na)
    ty = na
  END IF : IF fl = 0 THEN RETURN "BYVAL AS " & ty
  RETURN "BYVAL " & LEFT(na, fl - 1) & ") AS " & ty
END FUNCTION

' generating FB parameter list from C parameter list
' generiert FB-Parameterliste aus C-Parameterliste
FUNCTION ParaList(BYVAL T AS STRING) AS STRING
  IF T = "" THEN RETURN " ()"
  IF T = "void" THEN RETURN " CDECL()"
  DIM AS STRING la, r
  DIM AS INTEGER a = 1, p = findPara(T, a)
  WHILE p
    r += ParaListNaTy(MID(T, a, p - a)) & ", "
    a = p + 1
    p = findPara(T, a)
  WEND
  la = TRIM(MID(T, a), TRI)
  IF la = "..." THEN
    r += la
  ELSE
    r += ParaListNaTy(la)
  END IF : RETURN " CDECL(" & r & ")"
END FUNCTION

' translating a C function to a FB SUB/FUNCTION
' wandelt C-Function in FB SUB/FUNCTION
SUB SubFunc(BYVAL T AS STRING, BYREF Na AS STRING, BYREF Ty AS STRING)
  DIM AS INTEGER a1, p1, a2 = LEN(T) + 1, p2, kl
  DIM AS STRING pl
  DO '                                       Klammern der Parameterliste
    p2 = INSTRREV(T, ")", a2 - 1) : kl = 1
    FOR a2 = p2 - 2 TO 0 STEP -1
      SELECT CASE T[a2]
      CASE ASC(")") : kl += 1
      CASE ASC("(") : kl -= 1 : IF kl = 0 THEN EXIT FOR
      END SELECT
    NEXT : IF kl THEN ERRFL = -2 : Na = "" : Ty = "" : EXIT SUB
    pl = TRIM(MID(T, a2 + 2, p2 - a2 - 2), LTRI)
  LOOP UNTIL VALINT(pl) = 0
  pl = ParaList(pl)
  p1 = INSTRREV(T, ")", a2)
  IF p1 THEN
    a1 = INSTR(T, "(")
    Na = TRIM(MID(T, a1 + 1, p1 - a1 - 1), LTRI & "*")
    Ty = TRIM(LEFT(T, a1 - 1), LTRI)
    checkTy(Ty)
  ELSE
    getNaTy(TRIM(LEFT(T, a2), LTRI), Na, Ty)
    FOR i AS INTEGER = 1 TO UBOUND(NOFUNC)
      WITH NOFUNC(i)
        IF firstWord(Na, .Su) THEN
          Na = LTRIM(pl, " CDECL(BYVAL AS ")
          Na = LEFT(Na, LEN(Na) - 1) & MID(T, p2 + 1)
          checkNa(Na)
          IF LEN(.Er) THEN Ty = .Er
          ERRFL = 0
          EXIT SUB
        END IF
      END WITH
    NEXT
  END IF : IF INSTR(Na, ANY "(*,)") THEN ERRFL = -3
  IF LEN(Ty) THEN
    IF Ty = "ANY" OR RIGHT(Ty, 4) = " ANY" THEN Ty = "SUB" & pl : EXIT SUB
  ELSE
    checkTy(na) : Ty = na & "???" : ERRFL = -5
  END IF : Ty = "FUNCTION" & pl & " AS " & Ty
END SUB

' reading name and type from a C structure
' ermittelt Namen und Type einer C-Struktur
SUB getNaTy(BYVAL T AS STRING, BYREF Na AS STRING, BYREF Ty AS STRING)
  DIM AS INTEGER a, p = INSTRREV(T, ")")
  IF p THEN SubFunc(T, Na, Ty) : EXIT SUB
  p = INSTRREV(T, "*")
  IF p THEN
    Na = RTRIM(MID(T, p + 1), LTRI)
    Ty = LEFT(T, p)
  ELSE
    FOR p = LEN(T) - 1 TO 0 STEP -1
      IF T[p] >= ASC("a") THEN IF T[p] <= ASC("z") THEN EXIT FOR
      IF T[p] >= ASC("A") THEN IF T[p] <= ASC("Z") THEN EXIT FOR
    NEXT : IF p <= 0 THEN Na = "" : Ty = "" : ERRFL = - 4 : EXIT SUB
    p = INSTRREV(T, LTRI, p)
    IF p THEN
      Na = RTRIM(MID(T, p + 1), LTRI)
      Ty = LEFT(T, p)
    ELSE
      Ty = T
      Na = ""
    END IF
  END IF : checkNa(Na) : checkTy(Ty)
END SUB

' reading a new C header (#include)
' liest einen weiteren C-Header gem. #include
SUB include_(BYVAL Rd AS readDaten PTR, BYVAL T AS STRING)
  DIM AS INTEGER p
  IF RIGHT(T, 1) = ">" THEN
    p = INSTR(T, "<") + 1
  ELSE
    p = INSTR(T, """") + 1
  END IF : IF p <= 1 THEN AusKom(T) : EXIT SUB
  DIM AS STRING na = MID(T, p, LEN(T) - p)
  WITH *Rd
    readCHeader(na, .Eb + 1)
    .Wort = "#"
    AusRes(Rd, "'" & RIGHT(STR(.Eb + 100), 2) & "back from " & na & " to " & .FNam)
  END WITH
END SUB

' translating a '#' line
' wandelt Praeprozessor-Zeile fuer die Ausgabe
FUNCTION PreCoZeile(BYVAL Rd AS readDaten PTR, BYREF Z AS STRING) AS INTEGER
  AusMurx(Rd)
  DIM AS INTEGER p = 0, l = 1
  WITH *Rd
    FOR i AS INTEGER = 0 TO LEN(Z) - 1
      IF checkName(Z[i]) THEN p = i + 1 : EXIT FOR
    NEXT : IF p = 0 THEN RETURN 1
    FOR i AS INTEGER = p TO LEN(Z) - 1
      IF NOT checkName(Z[i]) THEN EXIT FOR
      l += 1
    NEXT
    SELECT CASE MID(Z, p, l)
    CASE "include" : include_(Rd, Z) : RETURN 0
    CASE "if"     : MID(Z, p, l) = "IF" : IfNeu("")
    CASE "ifdef"  : MID(Z, p, l) = "IFDEF" : IfNeu("")
    CASE "ifndef" : MID(Z, p, l) = "IFNDEF" : IfNeu(LTRIM(MID(Z, p + l + 1), LTRI))
    CASE "elif"   : Z = LEFT(Z, p - 1) & "ELSEIF" & MID(Z, p + l)
    CASE "else"   : MID(Z, p, l) = "ELSE"
    CASE "endif"  : MID(Z, p, l) = "ENDIF" : Z += IfCom() : RETURN 1
    CASE "error"  : MID(Z, p, l) = "ERROR"
    CASE "define" : MID(Z, p, l) = "DEFINE"
    CASE "undef"  : MID(Z, p, l) = "UNDEF" : RETURN 2
    END SELECT
    IF INSTR(Z, ANY "{[*%]}") THEN RETURN 2
    IF INSTR(Z, "void") THEN RETURN 2
    STRreplace(Z, "defined", "DEFINED")
    checkLogic(Z)
    checkQuotes(Z)
  END WITH : RETURN 1
END FUNCTION

' reading one (or multiple) line starting with '#'
' liest eine oder mehrere Zeilen fuer den Praeprozessor
SUB PreComp(BYVAL Rd AS readDaten PTR)
  WITH *Rd
    DIM AS STRING zeile = .Wort
    DO
      WHILE NOT EOF(.fnr)
        GET #.fnr, , .z
        IF checkZE(.z) THEN EXIT WHILE
        IF .z = ASC("*") THEN '                   startet ein Kommentar?
          IF RIGHT(zeile, 1) = "/" THEN
            readComm(Rd)
            zeile = RTRIM(zeile, "/")
            .z = ASC(" ")
          END IF
        END IF : zeile += CHR(.z)
      WEND : zeile = RTRIM(zeile, LTRI)
      IF RIGHT(zeile, 1) <> "\" THEN EXIT DO
      MID(zeile, LEN(zeile), 1) = "_"
      zeile += CHR(.z)
    LOOP UNTIL EOF(.fnr)
  END WITH
  SELECT CASE PreCoZeile(Rd, zeile)
  CASE 1 : AusRes(Rd, zeile)
  CASE 2 : AusKom("??? " & zeile)
  END SELECT
END SUB

' storing a FB ENUM block in RES
' speichert einen ENUM-Block in RES
FUNCTION BlockUNION(BYVAL Rd AS readDaten PTR, _
                    BYREF T AS STRING, _
                    BYVAL O AS STRING)AS STRING
  DIM AS INTEGER a, e = LEN(T)
  findGKlam(T, a, e) : IF e < a THEN AusKom("union " & T & ";")
  DIM AS STRING na = getName(T, a, e)
  RETURN O & "UNION " & na & NL & _
                BlockTyUn(Rd, T, a, e, na, O) & _
         O & "END UNION"
END FUNCTION

' storing a FB TYPE block in RES
' speichert einen TYPE-Block in RES
FUNCTION BlockTYPE(BYVAL Rd AS readDaten PTR, _
                   BYREF T AS STRING, _
                   BYVAL O AS STRING)AS STRING
  DIM AS INTEGER a, e = LEN(T)
  findGKlam(T, a, e) : IF e < a THEN AusKom("struct " & T & ";")
  DIM AS STRING na = getName(T, a, e)
  (*Rd).LaWo = (*Rd).Wort
  RETURN O & "TYPE " & na & checkTynam(na) & NL & _
                BlockTyUn(Rd, T, a, e, na, O) & _
         O & "END TYPE"
END FUNCTION

' generating FB lines for blocks
' erzeugt FB-Zeilen in einem Block (TYPE od. UNION)
FUNCTION BlockTyUn(BYVAL Rd AS readDaten PTR, _
                   BYREF T AS STRING, _
                   BYVAL S AS INTEGER, _
                   BYVAL E AS INTEGER, _
                   BYVAL N AS STRING, _
                   BYVAL O AS STRING) AS STRING
  DIM AS STRING r, na, ty, pa
  DIM AS INTEGER a, x
  FOR p AS INTEGER = S + 1 TO E - 1
    a = p
    p = INSTR(a, T, ";") : IF p >= E OR p = 0 THEN EXIT FOR
    pa = TRIM(MID(T, a, p - a), TRI)
    WHILE LEFT (pa, 1) = "#"
      x = INSTR(pa, NL) : IF x = 0 THEN x = LEN(pa)
      na = LEFT(pa, x - 1)
      PreCoZeile(Rd, na)
      r += na & NL
      pa = LTRIM(MID(pa , x + 1), LTRI)
    WEND : x = INSTR(pa, LTRI) - 1
    IF LEFT(pa, x) = "union" OR _
       LEFT(pa, x) = "struct" THEN
      a += 5
      x = E
      findGKlam(T, a, x)
      IF a > x THEN
        STRreplace(pa, NL, NL & "' ") : r += "'??? " & pa & NL
      ELSE
        p = INSTR(x + 2, T, ";") : IF p = 0 THEN p = E
        IF LEFT(ty, 4) = "unio" THEN
          r += BlockUNION(Rd, "{" & MID(T, a, x - a) & "};", O & EINR) & NL
        ELSE
          ty = TRIM(MID(T, x + 2, p - x - 2), TRI)
          na = LTRIM(ty, "*")
          pa = N & "_" & na & " {" & MID(T, a, x - a) & "};"
          AusRes(Rd, NL & BlockTYPE(Rd, pa, ""))
          checkTy(ty)
          ty = N & "_" & ty
          r += O & EINR & na & " AS " & ty & NL
        END IF
      END IF
    ELSE
      getNaTy(pa, na, ty)
      IF ERRFL THEN
        STRreplace(pa, NL, NL & "' ") : r += "'???" & ERRFL & " " & pa & NL
        ERRFL = 0
      END IF
      r += O & EINR & na & " AS " & ty & NL
    END IF
  NEXT : RETURN r
END FUNCTION

' generating FB lines for ENUM block
' erzeugt FB-Zeilen eines ENUM-Blockes
FUNCTION BlockENUM(BYVAL Rd AS readDaten PTR, _
                   BYREF T AS STRING, _
                   BYVAL S AS INTEGER, _
                   BYVAL E AS INTEGER) AS STRING
  DIM AS INTEGER p, a, x
  DIM AS STRING r, preco, pa
  FOR p AS INTEGER = S + 1 TO E - 1
    a = p
    p = INSTR(a, T, ",")
    IF MID(T, p - 1, 1) = "'" THEN p = INSTR(p + 1, r, ",")
    IF p = 0 OR p > E THEN p = E
    pa = TRIM(MID(T, a, p - a), TRI)
    WHILE LEFT (pa, 1) = "#"
      x = INSTR(pa, NL) : IF x = 0 THEN x = LEN(pa)
      preco = LEFT(pa, x - 1)
      PreCoZeile(Rd, preco)
      r += preco & NL
      pa = LTRIM(MID(pa , x + 1), LTRI)
    WEND
    checkLogic(pa)
    checkQuotes(pa)
    a = INSTR(pa, TRI)
    IF a THEN
      IF INSTR(pa, "=") = 0 THEN pa = LEFT(pa, a - 1) & " = " & MID(pa, a + 1)
    END IF : r += EINR & pa & NL
  NEXT : RETURN r
END FUNCTION

' storing ENUM block in RES
' speichert einen ENUM Block in RES
SUB typenum_(BYVAL Rd AS readDaten PTR, BYREF T AS STRING)
  DIM AS INTEGER a, e = LEN(T)
  findGKlam(T, a, e) : IF e < a THEN AusKom("typedef " & T & ";") : EXIT SUB
  DIM AS STRING neu = BlockENUM(Rd, T, a, e)
  RES += NL : IF ERRFL THEN AusKom("???" & ERRFL & " typedef " & T & ";")
  (*Rd).LaWo = (*Rd).Wort
  AusRes(Rd, "ENUM " & TRIM(MID(T, e + 2), TRI) & NL & _
                neu & _
             "END ENUM ")
END SUB

' reading an enum block from C header, storing FB ENUM in RES
' liest einen enum-C-Block aus .h, speichert FB-ENUM in RES
SUB enum_(BYVAL Rd AS readDaten PTR)
  DIM AS STRING zeile = "enum " & readCBlock(Rd)
  DIM AS INTEGER a, e = LEN(zeile)
  findGKlam(zeile, a, e) : IF e < a THEN AusKom(zeile & ";") : EXIT SUB
  DIM AS STRING neu = BlockENUM(Rd, zeile, a, e)
  DIM AS STRING na = TRIM(MID(zeile, e + 2), TRI)
  IF LEN(na) THEN na = " " & na
  RES += NL : IF ERRFL THEN AusKom("???" & ERRFL & " " & zeile & ";")
  (*Rd).LaWo = (*Rd).Wort
  AusRes(Rd, "ENUM" & na & NL & _
                neu & _
             "END ENUM ")
END SUB

' storing a TYPE line in RES
' speichert eine TYPE-Zeile in RES
SUB ZeileTYPE(BYVAL Rd AS readDaten PTR, BYVAL T AS STRING)
  DIM AS STRING na, ty
  getNaTy(MID(T, INSTR(T, " ")), na, ty)
  IF ERRFL THEN AusKom("???" & ERRFL & " typedef " & T & ";")
  IF na = ty THEN ty += TYKENN : TynamNeu(na)
  AusRes(Rd, "TYPE " & na & " AS " & ty)
END SUB

' storing a UNION block in RES
' speichert einen UNION-Block in RES
SUB typUnion_(BYVAL Rd AS readDaten PTR, BYREF T AS STRING)
  IF INSTRREV(T, "}") = 0 THEN ZeileTYPE(Rd, MID(T, 6)) : EXIT SUB
  DIM AS STRING neu = BlockUNION(Rd, MID(T, 6), "")
  IF ERRFL THEN AusKom("???" & ERRFL & " typedef " & T & ";")
  AusRes(Rd, NL & neu)
END SUB

' storing a TYPE block in RES
' speichert einen TYPE-Block in RES
SUB typStruct_(BYVAL Rd AS readDaten PTR, BYREF T AS STRING)
  IF INSTRREV(T, "}") = 0 THEN ZeileTYPE(Rd, MID(T, 7)) : EXIT SUB
  DIM AS STRING neu = BlockTYPE(Rd, MID(T, 7), "")
  IF ERRFL THEN AusKom("???" & ERRFL & " typedef " & T & ";")
  AusRes(Rd, NL & neu)
END SUB

' reading a typedef block from C header, storing FB translation in RES
' liest typedef-Block, wandelt in Basic-Zeile(n), speichert in RES
SUB typedef_(BYVAL Rd AS readDaten PTR)
  DIM AS STRING zeile = readCBlock(Rd)
  DIM AS INTEGER l = INSTR(zeile, LTRI) - 1
  IF l <= 0 THEN AusKom("typedef " & zeile & ";") : EXIT SUB
  WITH *Rd
    IF LEFT(zeile, l) = "enum" THEN typenum_(Rd, zeile) : EXIT SUB
    IF LEFT(zeile, l) = "union" THEN typUnion_(Rd, zeile) : EXIT SUB
    IF LEFT(zeile, l) = "struct" THEN typStruct_(Rd, zeile) : EXIT SUB
    DIM AS STRING na, ty
    getNaTy(zeile, na, ty)
    IF ERRFL THEN AusKom("???" & ERRFL & " typedef " & zeile & ";")
  END WITH : AusRes(Rd, "TYPE " & na & " AS " & ty)
END SUB

' reading a struct block from C header, storing FB translation in RES
' liest struct-Block, wandelt in Basic-Zeile(n), speichert in RES
SUB struct_(BYVAL Rd AS readDaten PTR)
  DIM AS STRING zeile = readCBlock(Rd)
  DIM AS STRING neu = BlockTYPE(Rd, zeile, "")
  RES += NL : IF ERRFL THEN AusKom("???" & ERRFL & " struct " & zeile & ";")
  (*Rd).LaWo = (*Rd).Wort : AusRes(Rd, neu)
END SUB

' reading a union block from C header, storing FB translation in RES
' liest union-Block, wandelt in Basic-Zeile(n), speichert in RES
SUB union_(BYVAL Rd AS readDaten PTR)
  DIM AS STRING zeile = readCBlock(Rd)
  DIM AS STRING neu = BlockUNION(Rd, zeile, "")
  RES += NL : IF ERRFL THEN AusKom("???" & ERRFL & " union " & zeile & ";")
  (*Rd).LaWo = (*Rd).Wort : AusRes(Rd, neu)
END SUB

' reading a static block from C header, storing as comment in RES
' liest static-Block, speichert als Kommentar in RES
SUB static_(BYVAL Rd AS readDaten PTR)
  DIM AS INTEGER klammer
  DIM AS STRING zeile
  DIM AS UBYTE z
  WITH *Rd
    WHILE NOT EOF(.fnr)
      GET #.fnr, , z
      zeile += CHR(z)
      IF z = ASC("{") THEN klammer = 1 : EXIT WHILE
    WEND
    WHILE NOT EOF(.fnr)
      GET #.fnr, , z
      zeile += CHR(z)
      IF z = ASC("}") THEN klammer -= 1 : IF klammer = 0 THEN EXIT WHILE
      IF z = ASC("{") THEN klammer += 1
    WEND
    IF .LaWo <> .Wort THEN RES += NL : .LaWo = .Wort
    AusKom(.Wort & " " & zeile)
  END WITH
END SUB

' killing C comment in text T
' entfernt ggf. C Kommentar aus Text
FUNCTION killCcomm(BYVAL T AS STRING) AS STRING
  DIM AS STRING r = T
  DIM AS INTEGER e, a = INSTR(r, "/*")
  WHILE a
    e = INSTR(a + 2, r, "*/") : IF e = 0 THEN e = LEN(T)
    r = LEFT(r, a - 1) & MID(r, e + 2)
    a = INSTR(a, r, "/*")
  WEND : RETURN r
END FUNCTION

' collecting untranslated lines, storing translation or comment in RES
' sammelt Reste, versucht zu wandeln (sonst Kommentar)
SUB murx_(BYVAL Rd AS readDaten PTR)
  WITH *Rd
    DIM AS STRING na, ty, zeile
    WHILE NOT EOF(.fnr)
      IF checkZe(.z) THEN EXIT WHILE
      zeile += CHR(.z)
      GET #.fnr, , .z
    WEND : .Murx += .Wort & RTRIM(killCcomm(zeile), LTRI)
    IF RIGHT(.Murx, 1) <> ";" THEN .Murx += NL : EXIT SUB
    IF INSTR(.Murx, ANY !"/+-^!=?{<>}&|") THEN AusMurx(Rd) : EXIT SUB
    zeile = LTRIM(.Murx, TRI & "}") '               Reste vom Vorgaenger
    zeile = RTRIM(zeile, LTRI & ";")
    getNaTy(zeile, na, ty) : IF ERRFL THEN AusMurx(Rd) : ty += " '???1" & ERRFL
    zeile = "DECLARE "
    IF LEFT(ty, 4) = "SUB " THEN
      zeile = zeile & "SUB " & na & MID(ty, 4)
    ELSEIF LEFT(ty, 9) = "FUNCTION " THEN
      zeile = zeile & "FUNCTION " & na & MID(ty, 9)
    ELSE
      zeile = "TYPE " & na & " AS " & ty
    END IF
    IF INSTR(zeile, ANY !"*\t\n\r[]") THEN AusMurx(Rd) : zeile += " '???2" & ERRFL
    .Murx = ""
    .Wort = "SuFu"
    AusRes(Rd, zeile)
  END WITH
END SUB

' reading a word from C header
' liest das naechste Wort aus .h (ggf. Kommentar/NLs verwerfen)
SUB readWort(BYVAL Rd AS readDaten PTR)
  WITH *Rd
    .Wort = ""
    WHILE NOT EOF(.fnr)
      GET #.fnr, , .z
      IF INSTR(CHR(.z), LTRI) THEN
        IF LEN(.Wort) THEN EXIT SUB
        IF .z = ASC(NL) THEN
          IF RIGHT(.Murx, LEN(NL)) = NL THEN AusMurx(Rd)
        ELSE
          .Murx += CHR(.z)
        END IF
      ELSE
        .Wort += CHR(.z)
        IF .Wort = "#" THEN
          PreComp(Rd) : .Wort = ""
        ELSEIF .Wort = "/*" THEN
          readComm(Rd) : .Wort = ""
        END IF
      END IF
    WEND
  END WITH
END SUB

' starting translation, reading C header
' liest die .h-Datei, startet Wandlung
SUB readCHeader(BYVAL F AS STRING, BYVAL Ebene AS INTEGER)
  DIM AS STRING nr = RIGHT(STR(Ebene + 100), 2)
  DIM AS readDaten rd
  WITH rd
    .Wort = "#"
    IF checkFNam(@rd, F) THEN AusRes(@rd, "'" & nr & .FNam) : EXIT SUB
    ?"=> ";.FNam
    DIM AS INTEGER e = UBOUND(F_OK) + 1
    REDIM PRESERVE AS STRING F_OK(e)
    F_OK(e) = .FNam
    .Eb = Ebene
    IF .Eb > EMAX THEN EMAX = .Eb
    .fnr = FREEFILE
    IF OPEN (.FNam FOR BINARY AS #.fnr) THEN
      ?"Kann nicht lesen: " & .FNam
    ELSE
      AusRes(@rd, "'" & nr & "file: " & .FNam)
      DO
        readWort(@rd)
        SELECT CASE .Wort
        CASE "typedef" : typedef_(@rd)
        CASE "union"   : union_(@rd)
        CASE "struct"  : struct_(@rd)
        CASE "static"  : static_(@rd)
        CASE "enum"    : enum_(@rd)
        CASE ELSE : murx_(@rd)
        END SELECT
      LOOP UNTIL EOF(.fnr) : CLOSE #.fnr
      AusMurx(@rd)
    END IF
  END WITH
END SUB

' main / Hauptprogramm
?CURDIR
readFilDat(PROG_NAME & ".ini")
readRepDat(REPPO, POST())
readRepDat(REPTY, TYPES())
readRepDat(REPFU, NOFUNC())

? "Starting: "; FOLD(0)
RES = getDatei("Start.bi") & "'00back from Start.bi to " & FOLD(0) & NL

readCHeader(FOLD(0), 1)

RES += NL & "'00file: Ende.bi" & NL & getDatei("Ende.bi")

writeBi(getFileNam(CURDIR), POST())
